/* ;-*-c++-*-
 * 
 * qmmenubutton.h
 *
 * $Id: qmmenubutton.h,v 1.4 2000/12/09 12:12:36 amos Exp $
 * 
 * Apollo sound player: http://www.apolloplayer.org
 * Copyright(C) 2000 Apollo Team.  See CREDITS file.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * The GNU General Public License is also available online at:
 *
 * http://www.gnu.org/copyleft/gpl.html
 */

#ifndef QMMENUBUTTON_H_INCLUDED
#define QMMENUBUTTON_H_INCLUDED

#include <qtoolbutton.h>
#include <qpopupmenu.h>

/*! \file qmmenubutton.h
  Definition of QmMenuButton class which displays a toolbutton with a popup menu.
*/

class QmMenuButton : public QToolButton
{
	Q_OBJECT
public:
	QmMenuButton(const QIconSet & s,
				 const QString & textLabel,
				 QWidget * parent,
				 const char * name = 0);
	virtual ~QmMenuButton();

signals:
	void menuClicked();
	void iconClicked();
	
protected:
	virtual void drawButton(QPainter *p);
	virtual void enterEvent(QEvent *e);
	virtual void leaveEvent(QEvent *e);
	virtual void mouseReleaseEvent(QMouseEvent *e);
	
private:
	bool 		 m_MouseOver;
	int			 m_PixmapWidth;
};

#endif // QMMENUBUTTON_H_INCLUDED
