/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  This file is part of MixMagic.

    Copyright (C) 2000 Jonas Borgstrm <jonas_b@bitsmart.com>.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#ifndef __MIXMAGIC_MAINWIN_H__
#define __MIXMAGIC_MAINWIN_H__

#include <gtk/gtkwidget.h>
#include "song.h"

#define MAINWIN(obj)         GTK_CHECK_CAST(obj, mainwin_get_type (), Mainwin)
#define MAINWIN_CLASS(klass)  GTK_CHECK_CLASS_CAST(klass, mainwin_get_type (), MainwinClass)
#define IS_MAINWIN(obj)       GTK_CHECK_TYPE(obj, mainwin_get_type ())

typedef struct _Mainwin Mainwin;
typedef struct _MainwinClass MainwinClass;

struct _Mainwin {
	GtkObject object;

	GtkWidget *toplevel;
	GtkWidget *appbar;

	GtkWidget *open_file_sel;   /* Open song dialog */
	GtkWidget *save_file_sel;   /* Save song dialog */

	Song *song;

	gboolean play_selection_flag;
	
	gchar *filename;          /* Filename of song being edited */
};

struct _MainwinClass 
{
        GtkObjectClass parent_class;
};

guint		mainwin_get_type	(void);
GtkObject *	mainwin_new		(const gchar *filename);
void 		mainwin_play_clicked 	(GtkWidget *widget, Mainwin *mainwin);
void 		mainwin_stop_clicked 	(GtkWidget *widget, Mainwin *mainwin);

#endif
