/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  This file is part of MixMagic.

    Copyright (C) 2000 Jonas Borgstrm <jonas_b@bitsmart.com>.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#ifndef __MIXMAGIC_MIXER_H__
#define __MIXMAGIC_MIXER_H__

#include "song.h"
#include "block.h"

#define MIX_BUFFER_SIZE ((SAMPLE_RATE / 11)  * 4)

void		mixer_play_song			(Song *block);
void		mixer_play_song_threaded	(Song *song);
void		mixer_stop_thread 		(void);
gboolean	mixer_is_playing		(void);
void		mixer_play_block_and_delete	(Song *song, Block *block);
float		mixer_calc_envelope 		(GList *list, gint pos);
void		mixer_mix_sample_into_buffer	(gint16 *buffer, gint16 *data, GList *amp_env, GList *pan_env, gfloat t_amp, gfloat  t_pan, gint position);

typedef struct _PlayBlockArgs PlayBlockArgs;

struct _PlayBlockArgs {
	Song *song;
	Block *block;
};

#endif
