/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  This file is part of MixMagic.

    Copyright (C) 2000 Jonas Borgstrm <jonas_b@bitsmart.com>.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#ifndef __MIXMAGIC_PLUGINS_H__
#define __MIXMAGIC_PLUGINS_H__

#include <gmodule.h>

#define OUTPUT_PLUGIN_VERSION 1

typedef enum _AudioFormat AudioFormat;
enum _AudioFormat {
	AFORMAT_U8,
	AFORMAT_S8,
	AFORMAT_U16_LE,
	AFORMAT_U16_BE,
	AFORMAT_S16_LE,
	AFORMAT_S16_BE
};

typedef struct _OutputPlugin OutputPlugin;
struct _OutputPlugin {
	gint version;
	GModule *module;
	gchar *info;	/* This text will be displayed in the pref dialog */

	void (* about) (void); /* Displays an about dialog */
	void (* configure) (void); /* Displays the configuration dialog */

	void (* init) (void); /* Initalizes the plugin */
	gboolean (* open) (AudioFormat format, gint rate, gint num_channels);
       	void (* write) (gpointer data, gint length);
       	void (* close) (void);
};


void		plugins_init 				(void);
void		plugins_free 				(void);
void		plugins_register_output_plugin 		(OutputPlugin *plugin);
void		plugins_unregister_output_plugin 	(OutputPlugin *plugin);
GList *		plugins_get_output_list 		(void);
#endif
