#include <curses.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/soundcard.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <pthread.h>
#include <X11/Xlib.h>
#include <mikmod.h>
#include "bufsize.h"
#define LBUF_SIZE 1500
#define MAXCUE 10
/*#define CHNUM 2*/

extern struct MDRIVER drv_djsuite;
extern int startatoffset;
extern int nextpattern[CHNUM];

signed short loadbuffer[BUF_SIZE*LBUF_SIZE];
int lbp, buffering=0;

signed short audiobuffer[50000];
signed short ab[BUF_SIZE];
audio_buf_info info;
int audio_fd;
int tmp;
int playerthreadworking;
int frags;
int first;
float speed;
int cuepoints[MAXCUE];
int cueratios[MAXCUE];
int cuenum=0;
char bfilename[255];
int ss,se,next,es,ee,last,mixpoint, advance;
char *filename;

pthread_mutex_t mutex;



Display *display;
Window w;        /* relative to which window                */
Window *rootret, *childret;      /*RETURN*/
int rootx, rooty;      /* RETURN*/
int faszom, winx[2], winy[2];    /* RETURN*/
int screen,he;
int low, band, high, d1, d2, res, cutoff,osc,osc2;
unsigned int maskret[2];
short input, buf[10000], inbuf[10000], ps[50000];   /* 5000 stereo frames */
int i,j, query, temp, psc, psc2;
signed int filled;
XButtonEvent xe;


/* STATE VARS */

int secondary=1;
int synchrostart=0;
int playing[CHNUM];
int command;
int low1l[CHNUM],band1l[CHNUM],high1l[CHNUM],cutoff1[CHNUM],reso1[CHNUM];
int low1r[CHNUM],band1r[CHNUM],high1r[CHNUM];
int low2l[CHNUM],band2l[CHNUM],high2l[CHNUM],cutoff2[CHNUM],reso2[CHNUM];
int low2r[CHNUM],band2r[CHNUM],high2r[CHNUM];
int bass[CHNUM],treble[CHNUM];

int longloop[CHNUM];
int play[CHNUM];


void playerthread(void);

void procbuf(signed short *ab, int chn)
{
  int i;
  
  i=0;
  if (startatoffset)
  {
    i=offset;
    startatoffset=0;
  };
  
  if (first)
  {
    for(;i<BUF_SIZE/2;i++)
    {
/*      low1l[chn]+=((band1l[chn]*cutoff1[chn])>>12);
      band1l[chn]+=((high1l[chn]*cutoff1[chn])>>12);
      high1l[chn]=audiobuffer[i]-low1l[chn]-((band1l[chn]*reso1[chn])>>8);
      ab[i]=((bass[chn]*(low1l[chn]+((band1l[chn]*reso1[chn])>>8)))>>12)+high1l[chn];
      i++;
      low1r[chn]+=((band1r[chn]*cutoff1[chn])>>12);
      band1r[chn]+=((high1r[chn]*cutoff1[chn])>>12);
      high1r[chn]=audiobuffer[i]-low1r[chn]-((band1r[chn]*reso1[chn])>>8);
      ab[i]=((bass[chn]*(low1r[chn]+((band1r[chn]*reso1[chn])>>8)))>>12)+high1r[chn];
*/      
      ab[i]=audiobuffer[i];
    };
    first=0;
  }  
  else {
    for(;i<BUF_SIZE/2;i++)
    {
/*      low1l[chn]+=((band1l[chn]*cutoff1[chn])>>12);
      band1l[chn]+=((high1l[chn]*cutoff1[chn])>>12);
      high1l[chn]=audiobuffer[i]-low1l[chn]-((band1l[chn]*reso1[chn])>>8);
      ab[i]+=((bass[chn]*(low1l[chn]+((band1l[chn]*reso1[chn])>>8)))>>12)+high1l[chn];
      i++;
      low1r[chn]+=((band1r[chn]*cutoff1[chn])>>12);
      band1r[chn]+=((high1r[chn]*cutoff1[chn])>>12);
      high1r[chn]=audiobuffer[i]-low1r[chn]-((band1r[chn]*reso1[chn])>>8);
      ab[i]+=((bass[chn]*(low1r[chn]+((band1r[chn]*reso1[chn])>>8)))>>12)+high1r[chn];
*/      
      ab[i]+=audiobuffer[i];
    };
  };
};

void InitAudio()
{
  int tmp;
  
  audio_fd=open("/dev/dsp",O_WRONLY,0);
  
  tmp = AFMT_S16_LE;
  ioctl(audio_fd, SNDCTL_DSP_SETFMT, &tmp);
  
  tmp = 1;
  ioctl(audio_fd, SNDCTL_DSP_STEREO, &tmp);
  
  tmp = 44100;
  ioctl(audio_fd, SNDCTL_DSP_SPEED, &tmp);
  
  tmp= 0x10000008;
  ioctl(audio_fd, SNDCTL_DSP_SETFRAGMENT, &tmp);

  ioctl(audio_fd, SNDCTL_DSP_GETOSPACE, &info);
  printw("fragtot: %d, size %d \n", info.fragstotal, info.fragsize);refresh();

}

void InitPlayer()
{
  beat[0]=800;notecounter[0]=0;looping[0]=1;
  playing[0]=1;playing[1]=0;pattern[0]=0;
  for(i=0;i<CHNUM;i++)
  {
    low1l[i]=0;band1l[i]=0;high1l[i]=0;
    low1r[i]=0;band1r[i]=0;high1r[i]=0;
    cutoff1[i]=80;reso1[i]=1000;bass[i]=(1<<12);
    bass[i]=0;
    longloop[0]=1;
    play[0]=0;
  };
  
  md_mode=DMODE_SOFT_MUSIC|DMODE_STEREO|DMODE_INTERP|DMODE_16BITS|DMODE_HQMIXER;
  md_mixfreq=44100;        
  MikMod_RegisterDriver(&drv_djsuite);
  MikMod_RegisterAllLoaders();
  md_reverb=0;            
  if (MikMod_Init("")) printw("lofasz \n");refresh();
  MikMod_InitChannels();
  MikMod_SelectChannel(0);
  
}

void InitX()
{
/*  display = XOpenDisplay(NULL);
  screen = XDefaultScreen(display);
  w=XCreateSimpleWindow(display, XRootWindow(display,screen), 0, 0, 1, 1, 1, 1,1);
  XSelectInput(display,w, KeyPressMask) ;
  XMapWindow(display,w);
  XFlush(display);
  XGrabKeyboard(display,w ,0,GrabModeAsync, GrabModeAsync, CurrentTime);*/
};

void InitCurses()
{
  initscr();cbreak();noecho();nodelay(stdscr,TRUE);keypad(stdscr,TRUE);

};

void CreateFile()
{
  FILE* beatfile;
  char f[255];

  strcpy(f, filename);
  beatfile=fopen((char *)strcat(f,".beat"),"w");
  fprintf(beatfile,"%s \n", filename);
  fprintf(beatfile,"%f %d %d %d %d %d %d \n",speed,ss,se,next,es,ee,last);  
  fclose(beatfile);

};

void main(argc, argv)
int argc;
char **argv;
{
  int tmp,i;
  int p=0;
  int shmid;
  int pch;
  
  int beats;
  
  
  MODULE *module;

      
/*  InitX();*/
  InitCurses();
  InitAudio();    
  InitPlayer();
  
  module= Player_Load((filename=argv[1]),18,0);
  Player_Start(module);
  
/*  printf("BETOLTVE \n");  */
    
  for(;;)
  {
    ioctl(audio_fd, SNDCTL_DSP_GETOSPACE, &info);
    frags=info.fragstotal-info.fragments;
    if (frags<2) 
     for(i=0;i<(2-frags);i++)
       {
         write(audio_fd, ab, BUF_SIZE);
         pch=0;
         first=1;
         if (playing[pch])
	 {
           MikMod_SelectChannel(pch);
 	   md_volume=128;
           MikMod_Update();
  	   procbuf(ab,pch);
         };
       }; 

/* flow control */
      if (play[0])
      { 
        if (advance==0)
	{
          if ((pf->sngpos>=se)&&longloop[0]) 
	    nextpattern[0]=ss;
	  if ((pf->sngpos>=se)&&(!longloop[0])) 
	  {
	    nextpattern[0]=next;
	    advance=1;
	  };
	};  
	  
	if (advance==1)
	{
	  if (pf->sngpos==last) 
  	  {
	    longloop[0]=1;advance=2;
	    nextpattern[0]=es;
          };
	}  
	
	if (advance==2)
	{
	  if ((pf->sngpos==ee)&&(longloop[0])) nextpattern[0]=es;
	}
	  
      };	


      if ((tmp=getch())!=ERR)
      {
       switch(tmp)
       {
        case 'q':
	case 'Q':
        {
	  CreateFile();
	  break;
        };
/*	case 'w':
	case 'W':
	{
	  beats=0;
	  break;
	};
	case 'e':
	case 'E':
	{
          beats++;
	  break;
	};
	case 'r':
	case 'R':
	{
	  
          beat[0]=pf->numrow/beats;
	  speed=(125.0*((float)(pf->sngspd+1))*(float)((float)pf->numrow/(float)beats))/((float)pf->bpm*50.0);
	  printw("speed: %f , %d %d %d \n", speed, (pf->sngspd), pf->bpm, pf->numrow);refresh();
	  break;
	};
	case 't':
	case 'T':
	{
          beats+=4;
	  break;
	};
	case 'y':
	case 'Y':
	{
          beats+=8;
	  break;
	};*/
        case 'l':
	case 'L':
	{
          looping[0]=1-looping[0];
	  break;
	};
	case 'k':
	case 'K':
	{
	  longloop[0]=0;
	};
	case KEY_LEFT:
	{
	  
          nextpattern[0]=pf->sngpos-1;
	  if (nextpattern[0]<0) nextpattern[0]=0; 
	  break;
	  
	};
	case KEY_RIGHT:
	{  
	  Player_NextPosition();
	  break;
	};  
        case 's':
	case 'S':
	{
          ss=pf->sngpos;
	  break;
	};
	case 'd':
	case 'D':
	{
	  se=pf->sngpos;
	  break;
	};
	case 'x':
	case 'X':
	{
	  es=pf->sngpos;
	  break;
	};
	case 'c':
	case 'C':
	{
	  ee=pf->sngpos;
	  break;
	};
	case 'a':
	case 'A':
	{
	  next=pf->sngpos;
	  break;
	};
	case 'z':
	case 'Z':
	{
	  last=pf->sngpos;
	  break;
	};
	case 58:
	{
	  mixpoint=pf->sngpos;
	  break;
	};
	case 56:
	{
	  longloop[0]=0;
	  break;
	};  
	case 'p':
	case 'P':
	{
	  Player_SetPosition(ss);
	  play[0]=1;longloop[0]=1;advance=0;looping[0]=0;
	  break;
	};
	case ' ':
	{ 
	  printw(" %d %d %d %d %d %d \n",ss,se,next,es,ee,last);refresh();
	  break;
	};  
       };	
      };
      
      if (pattern[0]) 
      {
        printw("+");refresh();
	pattern[0]=0;
	notecounter[0]=1;
      };
      if (onbeat[0]) 
      {
/*        printf("beat \n");*/
	onbeat[0]=0;
      };
  };

    
  
  Player_Stop();
  Player_Free(module);
  
  MikMod_Exit();
  
      
} 

